fediverser/apps/core/urls.py
from django.urls import path

from . import views

app_name = "fediverser-core"

urlpatterns = [
    path("", views.HomeView.as_view(), name="portal-home"),
    path(
        "reddit/invites/<str:key>/accept",
        views.RedditorAcceptInviteView.as_view(),
        name="redditor-accept-invite",
    ),
    path(
        "reddit/invites/<str:key>/decline",
        views.RedditorDeclineInviteView.as_view(),
        name="redditor-decline-invite",
    ),
    path("reddit/connect", views.RedditConnectionView.as_view(), name="reddit-connection-setup"),
    path("reddit/login", views.RedditLoginView.as_view(), name="reddit-login"),
    path("lemmy/connect", views.LemmySignupView.as_view(), name="lemmy-connect-setup"),
    path("lemmy/set-password", views.LemmySetPasswordView.as_view(), name="lemmy-set-password"),
    path("activity", views.UserActionListView.as_view(), name="activity-list"),
    path("instances", views.InstanceListView.as_view(), name="instance-list"),
    path("instances/create", views.InstanceCreateView.as_view(), name="instance-create"),
    path("instances/find", views.InstanceFinderView.as_view(), name="instance-find"),
    path("instances/<str:domain>", views.InstanceDetailView.as_view(), name="instance-detail"),
    path(
        "instances/<str:domain>/recommend/category",
        views.InstanceCategoryRecommendationCreateView.as_view(),
        name="instance-categoryrecommendation-create",
    ),
    path(
        "instances/<str:domain>/recommend/country",
        views.InstanceCountryRecommendationCreateView.as_view(),
        name="instance-countryrecommendation-create",
    ),
    path(
        "instances/<str:domain>/annotate/closed",
        views.InstanceClosedAnnotationCreateView.as_view(),
        name="instance-closedannotation-create",
    ),
    path(
        "instances/<str:domain>/annotate/abandoned",
        views.InstanceAbandonedAnnotationCreateView.as_view(),
        name="instance-abandonedannotation-create",
    ),
    path("communities", views.CommunityListView.as_view(), name="community-list"),
    path(
        "communities/create",
        views.CommunityCreateView.as_view(),
        name="community-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>",
        views.CommunityDetailView.as_view(),
        name="community-detail",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/repost/reddit",
        views.CommunityRepostRedditSubmissionView.as_view(),
        name="community-repost-reddit",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/recommend/category",
        views.CommunityCategoryRecommendationCreateView.as_view(),
        name="community-categoryrecommendation-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/ambassadors/apply",
        views.CommunityAmbassadorApplicationCreateView.as_view(),
        name="community-ambassador-application-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/feeds/create",
        views.CommunityFeedCreateView.as_view(),
        name="community-contentfeed-create",
    ),
    path(
        "reddit/submissions/<str:submission_id>",
        views.RedditSubmissionView.as_view(),
        name="redditsubmission-detail",
    ),
    path("subreddits", views.SubredditListView.as_view(), name="subreddit-list"),
    path("subreddits/create", views.SubredditCreateView.as_view(), name="subreddit-create"),
    path("subreddits/<str:name>", views.SubredditDetailView.as_view(), name="subreddit-detail"),
    path(
        "subreddits/<str:name>/subscribe", views.subscribe_to_subreddit, name="subreddit-subscribe"
    ),
    path(
        "subreddits/<str:name>/unsubscribe",
        views.unsubscribe_from_subreddit,
        name="subreddit-unsubscribe",
    ),
    path(
        "subreddits/<str:name>/recommend/category",
        views.SubredditCategoryRecommendationCreateView.as_view(),
        name="subreddit-categoryrecommendation-create",
    ),
    path(
        "subreddits/<str:name>/recommend/alternative",
        views.SubredditAlternativeRecommendationCreateView.as_view(),
        name="subreddit-alternativerecommendation-create",
    ),
    path(
        "subreddits/<str:name>/request/community",
        views.CommunityRequestCreateView.as_view(),
        name="subreddit-communityrequest-create",
    ),
    path("redditors", views.RedditorListView.as_view(), name="redditor-list"),
    path("redditors/<str:username>", views.RedditorDetailView.as_view(), name="redditor-detail"),
    path(
        "redditors/<str:username>/invite",
        views.RedditorInviteView.as_view(),
        name="redditor-send-invite",
    ),
    path(
        "api/community-requests",
        views.CommunityRequestListView.as_view(),
        name="api-community-request-list",
    ),
    path(
        "api/subreddits",
        views.RedditCommunityListView.as_view(),
        name="api-subreddit-list",
    ),
    path("api/nodeinfo", views.NodeInfoView.as_view(), name="nodeinfo-detail"),
    path(
        "api/fediverser-instances",
        views.FediversedInstanceListView.as_view(),
        name="fediverserinstance-list",
    ),
    path(
        "api/instance/recommendations",
        views.InstanceRecommendationsListView.as_view(),
        name="api-instancerecommendation-list",
    ),
    path(
        "api/changes",
        views.ChangeFeedEntryListView.as_view(),
        name="changefeedentry-list",
    ),
    path(
        "api/changes/<int:pk>",
        views.ChangeFeedEntryDetailView.as_view(),
        name="changefeedentry-detail",
    ),
    path("feed/changes", views.ChangeFeed(), name="changefeed-feed"),
]

fediverser/apps/core/templates/portal/community/create.tmpl.html
{% extends "portal/generic/form.tmpl.html" %}

{% block actions %}
<input type="submit" value="Submit" class="button" />
{% endblock %}

fediverser/apps/core/templates/portal/community/detail.tmpl.html
{% extends "portal/generic/base.tmpl.html" %}
{% load fediverser humanize wagtailadmin_tags %}

{% block main_content %}
<dl>
  <dt>Community Page</dt>
  <dd><a href="{{ object.url }}"}} target="_blank">{{ object.fqdn }}</a></dd>
  {% if object.annotation.category %}
  <dt>Category</dt>
  <dd>{{ object.annotation.category.full_name }}</dd>
  {% endif %}

  {% with object|subreddit_counterparts as counterparts %}
  {% if counterparts.exists %}
  <dt>Recommendation as alternative to:</dt>
  <dd>
    {% for subreddit in counterparts.all %}
    <a href="{% url 'fediverser-core:subreddit-detail' subreddit.name %}">{{ subreddit }}</a>
    <br />
    {% endfor %}
  </dd>
  {% endif %}
  {% endwith %}
</dl>
<hr />

{% if not object.annotation.category %}
<h3>Category</h3>
{% if not user|pending_community_category_proposal:object %}
<p>This community has not been properly categorized yet. Please indicate the category which closest describe it:</p>
<form action="{% url 'fediverser-core:community-categoryrecommendation-create' name=object.name instance_domain=object.instance.domain %}" method="POST" novalidate>
  {% csrf_token %}
  <ul class="fields">
    {% for field in category_picker_form.visible_fields %}
    <li>
      {% include "wagtailadmin/shared/field.html" %}
    </li>
    {% endfor %}
    <li>
      <input type="submit" value="Submit Category" class="button" />
    </li>
  </ul>
</form>
{% else %}
<p>You already recommended a category! Please check your <a href="{% url 'fediverser-core:activity-list' %}">activity page</a> for more information.</p>
{% endif %}
{% endif %}


<h2>Community Ambassadors</h2>
<p>Interested in helping {{ object.fqdn }} grow and become a <strong>Community Ambassador</strong>? You will be able to:</p>

<ul>
  <li>Create curated sources of content which can be easily shared with the community</li>
  <li>Reach out to users on Reddit that might be interested in migrating to the Fediverse</li>
  <li>Define policies for content bridging between the Fediverse and Reddit</li>
</ul>
{% if user|is_ambassador:object %}
You are enrolled as an ambassador for {{ object.fqdn }}.
{% elif user|has_pending_ambassador_application:object %}
<p>Your application has been received and will be reviewed by an admin.</p>
{% else %}
<form action="{% url 'fediverser-core:community-ambassador-application-create' name=object.name instance_domain=object.instance.domain %}" method="POST" novalidate>
  {% csrf_token %}
  <input type="submit" value="Submit Application" class="button" />
</form>
{% endif %}

<hr />
<h2>Content Feeds</h2>
<p>
  Community Ambassadors can select and curate a list of content feeds
  from around the web. The idea is to help find out the content that
  is relevant to the communities on the Fediverse and stimulate user
  participation. Take a look at the entries below, share them directly
  on {{ object.fqdn }} with one click.
</p>

{% if user|is_ambassador:object %}
<p>As a Community Ambassador, you can add new feeds. Please add the URL for RSS or Atom feed</p>
<form action="{% url 'fediverser-core:community-contentfeed-create' name=object.name instance_domain=object.instance.domain %}" method="POST" novalidate>
  {% csrf_token %}
  {% formattedfield field=community_feed_form.feed %}
  <input type="submit" value="Add Feed" class="button" />
</form>
{% endif %}

<hr />

{% with user|lemmy_create_post_url as lemmy_post_url %}
{% with object|latest_feed_entries as feed_entries %}
{% with object|submissions_from_related_subreddits as reddit_submissions %}
{% if feed_entries.exists or reddit_submissions.exists %}

<h2>Content Suggestions</h2>
<p>Here are some of the recent entries that might be interesting to post to {{ object.fqdn }}</p>
<table class="listing listing--inline-actions">
  <thead>
    <tr>
    <th scope="col">Title</th>
    <th scope="col">Source</th>
    <th scope="col">Published On</th>
    <th scope="col">Post to Lemmy</th>
  </thead>
  <tbody>
    {% for submission in reddit_submissions %}
    <tr>
      <td><a href="{% url 'fediverser-core:redditsubmission-detail' submission_id=submission.id %}">{{ submission.title }}</a></td>
      <td>{{ submission.author }} on {{ submission.subreddit.name }}</td>
      <td>{{ submission.created|naturaltime }}</td>
      <td>
        {% if submission.can_be_submitted_automatically and not submission.is_self_post %}
        <a class="button text-replace button--icon"
            role="link"
            href="{% url 'fediverser-core:community-repost-reddit' name=object.name instance_domain=object.instance.domain %}?url={{ submission.url|urlencode}}">
          {% icon name="upload" %}
          Post
        </a>
        {% endif %}
      </td>
    </tr>
    {% endfor %}
    {% for entry in feed_entries %}
    <tr>
      <td><a href="{{ entry.link }}" target="_blank">{{ entry.title }}</a></td>
      <td>{{ entry.feed.link }}</td>
      <td>{{ entry.modified|naturaltime }}</td>
      <td>
        {% if lemmy_post_url is not None %}
        <a class="button text-replace button--icon"
            role="link"
            href="{{ lemmy_post_url }}?url={{ entry.link|urlencode}}">
          {% icon name="upload" %}
          Post
        </a>
        {% endif %}
      </td>
    </tr>
    {% endfor %}
  </tbody>
</table>
{% else %}
<p>The Community Ambassadors for {{ object.fqdn }} have not defined any RSS feed that might be relevant</p>
{% endif %}
{% endwith %}
{% endwith %}
{% endwith %}

{% endblock %}

{% block extra_js %}
{{ block.super }}
{{ category_picker_form.media.js }}
{% endblock %}

{% block extra_css %}
{{ block.super }}
{{ category_picker_form.media.css }}
{% endblock %}

fediverser/apps/core/templates/portal/community/list.tmpl.html
{% extends "portal/generic/listing.tmpl.html" %}
{% load wagtailadmin_tags %}

{% block listing %}
<table class="listing listing--inline-actions">
  <thead>
    <tr>
      <th scope="col">Community</th>
      <th scope="col">Alternative to</th>
      <th scope="col">Category</th>
    </tr>
  </thead>
  <tbody>
    {% for community in object_list %}
    <tr>
      <td class="title">
        <div class="title-wrapper">
          <a href="{% url 'fediverser-core:community-detail' name=community.name instance_domain=community.instance.domain %}" target="_blank">
            {{ community.fqdn }}
          </a>
          <a href="{{ community.url }}" target="_blank">🌐</a>
        </div>
      </td>
      <td>
        {% for recommendation in community.recommendations.all %}
        <a href="{% url 'fediverser-core:subreddit-detail' name=recommendation.subreddit.name %}">{{ recommendation.subreddit }}</a>
        {% empty %}
        No recommendation yet
        {% endfor %}
      </td>
      <td>{{ community.category.full_name|default:"Not categorized yet" }}</td>
    </tr>
    {% endfor %}
  </tbody>
</table>
{% endblock %}